//construct a new spiner
function Spinner(div, color, size, interval)
{
	this.spinner = document.getElementById(div);
	this.color = color;
	this.size = size;
	this.interval = interval;
	this.rot = 0;
	this.tasks = 0;
	this.timer = null;
	
	this.image = new Image(size, size);
	this.image.src = "Images/Spinner/" + color + ".png";
	
	this.spinner.style.display = 'none';
	this.spinner.innerHTML = "<canvas id='" + div + "canvas' width=" + size + " height=" + size + ">";
	this.context = document.getElementById(div + "canvas").getContext("2d");
}

//start the spinner, disregarding reference counts
Spinner.prototype.start = function(self)
{
	if(!self) self = this;
	
	if(!self.timer)
	{
		self.spinner.style.display = 'block';
		self.timer = setInterval(self.spin, self.interval, self);
	}
}

//stop the spinner, resetting any reference counts to 0
Spinner.prototype.stop = function(self)
{
	if(!self) self = this;
	
	if(self.timer)
	{
		self.spinner.style.display = 'none';
		clearInterval(self.timer);
		self.timer = null;
		self.tasks = 0;
	}
}

//add a task, incrementing the reference count
Spinner.prototype.addTask = function(self)
{
	if(!self) self = this;
	self.tasks++;
	
	if(self.tasks == 1 && !self.timer)
	{
		self.spinner.style.display = 'block';
		self.timer = setInterval(self.spin, self.interval, self);
	}
}

//remove a task, decrementing the reference count
Spinner.prototype.subtractTask = function(self)
{
	if(!self) self = this;
	self.tasks--;
	
	if(self.tasks == 0 && self.timer)
	{
		self.spinner.style.display = 'none';
		clearInterval(self.timer);
		self.timer = null;
	}
}

//animate the spin
Spinner.prototype.spin = function(self)
{
	if(!self) self = this;
	
	self.rot += .5236;
	
	self.context.clearRect(0,0, self.size, self.size);
	self.context.save();
		self.context.translate(self.size/2, self.size/2);
		self.context.rotate(self.rot);
		self.context.translate(-self.size/2, -self.size/2);
		self.context.drawImage(self.image, 0, 0, self.size, self.size);
	self.context.restore();
}