var showGuide = true;
var droppedVideo = null;
var nextPage;

var requestedVideoID = null;

function fetchVideoFromID(id)
{
	requestedVideoID = id;
	var url = "http://www.youtube.com/watch?v=" + id;	
	makeRequest(url, parseVideo, false, false);
}

function fetchVideoFromURL(url)
{
	id = '';
	var videoID = url.match(/youtube.com\/.*v=([^& ]*)/);
	
	if(videoID)
	{
		id = videoID[1];
		fetchVideoFromID(id);
	}
		
	var videoHash = url.match(/youtube.com\/.*cthru\?(.*)/);
	
	if(videoHash)
	{
		fetchVideoFromHash(videoHash[1]);
		return;
	}
	
	if(!id)
		pushMessage('link', "<font color='#FFF' size='5px'> Invalid URL<br></font>Not recognized as a YouTube URL", 
		[
			{"title":"Cancel", "src":"Images/back.png", "hover":"Images/back_over.png", "action":"popMessage();$('urlfield').select();"},
			{"title":"View in browser", "src":"Images/launch.png", "hover":"Images/launch_over.png", "action":"popMessage();widget.openURL('" + url + "');"}
		]);
}

function fetchVideoFromHash(hash)
{
	var url = "http://youtube.com/cthru?" + hash;
	makeRequest(url, fetchVideoFromResults, false, false);
}

function fetchVideoFromResults()
{
	var HTML = videoRequest.responseText;
	var id='';
	
	theMatch = HTML.match(/video_id=([^&]*)/i);
	
	if(theMatch) fetchVideoFromID(theMatch[1]);
	else log("error fetching video from results");
}

function fetchRelatedVideosFromResults()
{
	var HTML = videoRequest.responseText;
	theMatch = HTML.match(/\?search=related[^"]*/i);
	
	if(theMatch)
	{
		var url = "http://youtube.com/results" + theMatch[0];
		makeRequest(url, parseVideos, false);
	} else
		log("error fetching related videos from results");
}

function fetchRelatedVideos(video, n)
{
	header = "Related Videos";
	subheader = video.title;
	
	$$selectedIndex("browse_popup", 0);
	$$text("browse_label", "Similar");
	$$displayed("time_label", false);
	$$displayed("category_label", false);
	$$displayed("time_popup", false);
	$$displayed("category_popup", false);
	browser.style.display = 'none';
	$('urlfield').style.display = "none";
	$('searchfield').style.display = "none";
	$('codefield').style.display = "none";
	$('dimmer').style.display = "none";
	
	var url = "http://www.youtube.com/watch?v=" + video.id;	
	makeRequest(url, fetchRelatedVideosFromResults, false);
}

function fetchResponseVideos(video, n)
{
	$$selectedIndex("browse_popup", 0);
	$$text("browse_label", "Responses");
	browser.style.display = 'none';
	$$displayed("time_label", false);
	$$displayed("category_label", false);
	$$displayed("time_popup", false);
	$$displayed("category_popup", false);
	$('urlfield').style.display = "none";
	$('searchfield').style.display = "none";
	$('codefield').style.display = "none";
	$('dimmer').style.display = "none";
	
	header = "Video Responses";
	subheader = video.title;
	
	var url = "http://www.youtube.com/video_response_view_all?v=" + video.id;
	makeRequest(url, parseVideos, false, false);
}

function fetchMyVideos(username)
{
	header = "My Videos";
	subheader = "";
	
	fetchUserVideos(username, 0);
}

function fetchMyFavorites(username)
{
	header = "My Favorites";
	subheader = "";
	
	var url = "http://www.youtube.com/profile_favorites?user=" + username;
	makeRequest(url, parseVideos, false, true);
}

function fetchMySubscriptions(username)
{	
	var url = "http://www.youtube.com/profile_subscriptions?user=" + username;
	makeQuietRequest(url, parseSubscriptions);
}

function fetchMyPlaylists(username)
{	
	var url = "http://www.youtube.com/profile_play_list?user=" + username;
	makeQuietRequest(url, parsePlaylists, false, true);
}

function fetchVideosFromPlaylist(id, title)
{
	header = title;
	subheader = "";
	
	var url = "http://www.youtube.com/view_play_list?p=" + id;
	makeRequest(url, parseVideos);
}

function fetchUserVideos(username, n)
{	
	header = username.replace(/\b[a-z]/g, function(s) {return s.toUpperCase();}) + "'s Videos";
	subheader = "";
	
	var url = "http://www.youtube.com/profile_videos?user=" + username.replace(' ', "%20");
	makeRequest(url, parseVideos, false, true);
}

function fetchMatchingVideos(query, n)
{
	header = "Video Results";
	subheader = query;
	
	var url = "http://youtube.com/results?search_query=" + query.replace(' ', "%20") + "&search=Search";
	makeRequest(url, parseVideos, false, true);
}

function fetchListedVideos(list, timeframe, category, language)
{
	header = lists[list] + " " + ((list != 'mr' && list != 'rf') ? timeframes[timeframe] : '');
	subheader = (category != 0) ? categories[category] : "";
	
	var url = "http://youtube.com/browse?s=" + list + "&t=" + timeframe + "&c=" + category + "&l=" + language;
	
	makeRequest(url, parseVideos, false, true);
}

var videoRequest = null;
var header = "";
var subheader = "";

var keptURL = "null";
var keptHandler = null;

function fetchMoreVideos()
{
	makeRequest(keptURL, keptHandler, nextPage);
}

function reloadGuide(show)
{
	showGuide = show;
	header = keptHeader;
	subheader = keptSubHeader;
	makeRequest(keptURL, keptHandler);
}

function makeRequest(url, handler, page, keep)
{
	if(keep)
	{
		keptURL = url;
		keptHandler = handler;
		keptHeader = header;
		keptSubHeader = subheader;
	}
	
	if(page)
	{
		if(url.match('profile_videos')) url += "&page=" + page
		else url += "&p=" + page;
	}
	
	stopVideo();
	hideUpdateInfo();
	hideVideoInfo();
	clearGuide();
	if(spinner) spinner.start();

	if (videoRequest != null)
	{
		videoRequest.abort();
		videoRequest = null;
	}
	
	videoRequest = new XMLHttpRequest();

	videoRequest.onload = handler;
	videoRequest.onreadystatechange = receiveResponse;
	videoRequest.open("GET", url);
	videoRequest.send(null);
}

function makeQuietRequest(url, handler)
{
	if (videoRequest != null)
	{
		videoRequest.abort();
		videoRequest = null;
	}
	
	videoRequest = new XMLHttpRequest();

	videoRequest.onload = handler;
	videoRequest.onreadystatechange = receiveResponse;
	videoRequest.open("GET", url);
	videoRequest.send(null);
}

function receiveResponse()
{
    //check for a completed request
	if(videoRequest.readyState == 4)
	{
		if(videoRequest.status != 200)
		{	//display error
			spinner.stop();
			pushMessage('connection', "<font color='#FFF' size='5px'>No Signal<br></font>You do not appear to be connected to the internet.", 
				[{"title":"Dismiss", "src":"Images/back.png", "hover":"Images/back_over.png", "action":"popMessage();focusSearchField()"}]);			
		}
	}
}

// special processing of login for viewing of flagged videos

var loginReq = null;
var loginResult = null;
var nextVideoID = null;

function logIn(next_id)
{
	nextVideoID = next_id;
	
	var user = $value('userfield');
	var pass = $value('passwordfield');
	
	log("Logging in... (" + user + ", " + pass + ")");
	
	if(!user || !pass)
	{
		spinner.stop();
		pushMessage('flagged', "<font color='#FFF' size='5px'>Flagged Video<br></font>Please provide account information to view flagged videos.", 
		[
			{"title":"Return to guide", "src":"Images/guide.png", "hover":"Images/guide_over.png", "action":"popMessage();"},
			{"title":"Enter account information", "src":"Images/login.png", "hover":"Images/login_over.png", "action":"showBack(); $('userfield').focus(); popMessage();"}
		]);
		return;
	}
	
	var command  = "curl -L -c /tmp/mytube_cookies 'http://www.youtube.com/login'";
	    command += " -d 'current_form=loginForm&username="+user+"&password="+pass+"&action_login=Log%20In'";
	
	log(command);

	loginReq = widget.system(command, confirmAge);
}

function confirmAge()
{
	if(loginReq.outputString.match(/errorBox/i))
	{
		spinner.stop();
		pushMessage('flagged', "<font color='#FFF' size='5px'>Flagged Video<br></font>Could not log in with provided account information.", 
		[
			{"title":"Return to guide", "src":"Images/guide.png", "hover":"Images/guide_over.png", "action":"popMessage();"},
			{"title":"Enter account information", "src":"Images/login.png", "hover":"Images/login_over.png", "action":"showBack(); $('userfield').focus(); $('userfield').select(); popMessage();"}
		]);
		return;
	}
	
	log("Confirming age...");
	
	var postLoginURL = "/watch?v=feZaHVVLSrE";
	if(nextVideoID != null) postLoginURL = "/watch?v=" + nextVideoID;
	
	log("Attempting to load " + postLoginURL);
	
	var command  = "curl -L -c /tmp/mytube_cookies -b /tmp/mytube_cookies 'http://www.youtube.com/verify_age'";
	    command += " -d 'next_url=" + postLoginURL + "&action_confirm=Confirm'";
	
	log(command);
	
	loginResult = widget.system(command, postLoginHandler);
}