name = 'mytube';
version = '1.5';

progressUpdateID = null;

spinner = null;

var mouseX;
var mouseY;
var videos;
var downloads = new Array();
var isPlaying = false;
var paused = false;
var unpauseOnShow = false;
var onFlipToFront = null;
var searchfieldFocused = true;
var urlfieldFocused = false;
var cursorShown = false;
var scrollOnShow = false;

function load()
{
	showCursor();
	var cursorShown = true;
	widget.onremove = showCursor;
		
	$$html('version', version);
	
	dimmerTarget = $("searchfield");
	$$displayed('searchfield', true);
	$$displayed('urlfield', false);
	
	$$displayed('front', true);
	$$displayed('messageScreen', false);
	
	window.document.onmousemove = function(e) {
		mouseX = e.pageX;
		mouseY = e.pageY;
		
		//log("("+mouseX+","+mouseY+")");
		
		if(scrubbing) scrub(fullscreen);
		$('scrubline').style.left = Math.min(Math.max(mouseX-3, 57), 206) + 'px';
		$$displayed('scrubline', (isPlaying && mouseX > 59 && mouseX < 209 && mouseY > 208 && mouseY < 223) || scrubbing);
		$('fs_scrubline').style.left = Math.min(Math.max(mouseX-3, 200), screen.width - 100) + 'px';
		$$displayed('fs_scrubline', (isPlaying && mouseX > 202 && mouseX < (screen.width - 98) && mouseY > (screen.height - 48)) || scrubbing);
		
		if(fullscreen) showFSControls();
	};

	CreateInfoButton('info', { foregroundStyle: 'white', onclick: 'showBack', backgroundStyle: 'white', frontID: 'front' });
    CreateGlassButton('done', { text: 'Done', onclick: 'showFront' });
    CreateGlassButton('donate', { text: 'Donate', onclick: 'donate' });
    
	loadPreferences();

	//register widget as trusted flash player
	uid = widget.system("/usr/bin/id -un", null).outputString;
	uid = uid.substr(0, uid.length-1);
	if(!pathExists("/Users/" + uid + "/Library/Preferences/Macromedia/Flash Player/#Security/FlashPlayerTrust/com.interdimensionmedia.mytube.cfg"))
	{
		widget.system("/bin/mkdir -p '/Users/" + uid + "/Library/Preferences/Macromedia/Flash Player/#Security/FlashPlayerTrust'", null).outputString;
		widget.system("/bin/echo \"/Users/" + uid + "/Library/Widgets/myTube.wdgt\n\n\n\" > '/Users/" + uid + "/Library/Preferences/Macromedia/Flash Player/#Security/FlashPlayerTrust/com.interdimensionmedia.mytube.cfg'", null).outputString;
	}
	
	
	spinner = new Spinner('spinner', 'blue', "32", 100);
	
	searchfieldFocused = false;
	$('searchfield').onfocus = function(e) { searchfieldFocused = true; hideDimmer(e); }
	$('searchfield').onblur = function(e) { searchfieldFocused = false; showDimmer(e); }
	urlfieldFocused = false;
	$('urlfield').onfocus = function(e) { urlfieldFocused = true; hideDimmer(e); }
	$('urlfield').onblur = function(e) { urlfieldFocused = false; showDimmer(e); }

	checkForUpdate();
	checkForPatch();
	checkForRegistration();
	
	if(window.widget)
	{
		widget.onremove = remove;
		widget.onhide = hideWidget;
		widget.onshow = showWidget;
	}
	
	//logIn();
}

function pathExists(path)
{
	return (widget.system("ls \"" + path + "\"", null).errorString == null);
}

function remove()
{
	// widget.setPreferenceForKey(null, preference);
}

var dashboardHidden = false;

function hideWidget()
{
	switch($selectedIndex('leaving_popup'))
	{	
		//pause
		case 0: if(isPlaying && !paused)
				{
					unpauseOnShow = true;
					togglePlayback();
				}
		break;
		//guide
		case 1: stopVideo(); hideVideoInfo(); startScrolling();
		break;
		//volume
		case 2: attenuateVolume();
		break;
	}
	
	if(scrollTimer)
	{
		clearInterval(scrollTimer);
		scrollTimer = null;
		scrollOnShow = true;
	}
	dashboardHidden = true;
	showCursor();
}

function showWidget()
{
	dashboardHidden = false;
	if(fullscreen)
	{
		widget.resizeAndMoveTo(0, 0, screen.width, screen.height);
		hideCursor();
	}
	
	switch($selectedIndex('leaving_popup'))
	{
		//pause
		case 0: if(paused && unpauseOnShow)
				{
					unpauseOnShow = false;
					togglePlayback();					
				}
		break;
		//volume
		case 2: if(attenuated) attenuateVolume();
		break;
	}
	
	if(scrollOnShow)
		scrollTimer = setInterval(scrollGuide, 50);
	
	checkForUpdate();
	checkForPatch();
	checkForRegistration();
}

function dragEnter(e)
{
	e.preventDefault();
}

function dragOver(e)
{
	e.preventDefault();
}

function drop(e)
{
	var url = data = e.dataTransfer.getData('text/plain');	
	followLink(url);
}

function showBack(event)
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	if(isPlaying) stopVideo();

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if(onFlipToFront && $value('userfield'))
		browse_popupHandler(onFlipToFront);
	else
		focusSearchField();
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
		
	clearTimeout(progressUpdateID);
	
	progressUpdateID = setTimeout("updateVideoProgress()", 1000);
	setPreference($value('userfield'), 'userfield');
	setPreference($value('passwordfield'), 'passwordfield');
	
	
}

function hideDimmer(event)
{
	$$displayed('dimmer', false);
	dimmerTarget.focus();
	dimmerTarget.select();
}

function showDimmer(event) 
{
	dimmer = $('dimmer');
	var dimmerID = dimmerTarget.id;
	if(dimmerID == 'codefield') dimmerID = 'urlfield';
	dimmer.src = "Images/" + dimmerID + "_dimmer.png";
	dimmer.style.display = "block";
}

function focusSearchField(event, paste)
{
	var searchfield = document.getElementById("searchfield");
	var urlfield = document.getElementById("urlfield");
	var browser = document.getElementById("browser");
	var dimmer = document.getElementById("dimmer");
	
	var time_label = document.getElementById("time_label");
	var time_popup = document.getElementById("time_popup");
	var category_label = document.getElementById("category_label");
	var category_popup = document.getElementById("category_popup");
		
	browser.style.display = "none";
	time_label.style.display = "none";
	time_popup.style.display = "none";
	category_label.style.display = "none";
	category_popup.style.display = "none";
	
	dimmer.style.display = "none";
	urlfield.style.display = "none";
	searchfield.style.display = "none";
	codefield.style.display = "none";	

	if(paste)
	{
		$$selectedIndex('browse_popup', 3);
		$$text('browse_label', "Paste Link");
		dimmerTarget = urlfield;
	}
	else if(event && event.altKey)
	{
		$$selectedIndex('browse_popup', 2);
		$$text('browse_label', "All Channels");
		searchfield.title = "Search All Channels";
		dimmerTarget = searchfield;
		
	} else {
		$$selectedIndex('browse_popup', 1);
		$$text('browse_label', "All Videos");
		searchfield.title = "Search All Videos";
		dimmerTarget = searchfield;
	}
	
	dimmerTarget.style.opacity = "1";
	dimmerTarget.style.display = "block";
	dimmerTarget.focus();
	dimmerTarget.select();
}

function searchVideos(event)
{
	query = event.target.value;
	if(!query) return;
	
	clearMessages();
	
	if(query.match(/http:/i) || query.match(/www./i))
	{
		followLink(query);
		return;
	}
	
	if(document.getElementById("browse_popup").value == "All Channels")
		fetchUserVideos(query, 1);
	else
		fetchMatchingVideos(query, 1);
}

function followLink(url)
{
	var user = url.match(/user=([^&]*)/i);
	
	if(user) fetchUserVideos(user[1], 1);
	else fetchVideoFromURL(url);
		
	setTimeout("document.getElementById('urlfield').blur()", 10);
	setTimeout("document.getElementById('dimmer').style.display = 'block'", 10);
}

function checkForRegistration()
{
	var code = myTubePlugin.getCode();
	
	log("MyTube registration code: " + code);
	
	if(code != null && code != $value("codefield"))
	{
		$("codefield").value = code;
		register(code);
	}
}

function register(code)
{
	setPreference(code, 'codefield');
	
	if(myTubePlugin)
    {
		var valid = myTubePlugin.validateCode(code);
		showRegistrationScreen(valid);
    } else
		showRegistrationScreen(false);
}

function showRegistrationScreen(valid)
{
	var HTML;
	
	if(valid)
		pushMessage('registration', "<font color='#FFF' size='5px'>Thank you!<br></font>Best wishes for a truly pleasurable viewing experience.",
			[{"title":"Dismiss", "src":"Images/back.png", "hover":"Images/back_over.png", "action":"popMessage();focusSearchField();"}]);
	else
		pushMessage('registration', "<font color='#FFF' size='5px'>Invalid Code<br></font>Please double check for typos or paste the code directly.",
		[
			{"title":"Dismiss", "src":"Images/back.png", "hover":"Images/back_over.png", "action":"popMessage()"},
			{"title":"Donate", "src":"Images/donate.png", "hover":"Images/donate_over.png", "action":"popMessage()"}			
		]);
}
////////////////////////////////////////////////////////////////////////////
var messages = new Array();

function message(id, html, buttons)
{
	this.id = id;
	this.html = html;
	this.buttons = buttons;
}

function createEvalClosure(str) {
	return function() { eval(str); };
}

function createClosure(fn, args) {
	return function() { fn.call(this, args) };
}

function pushMessage(id, html, buttons)
{
	removeMessage(id);
	
	var newMessage = new message(id, html, buttons);
	messages.push(newMessage);
	showMessage(messages[messages.length-1]);	
}

function popMessage()
{	
	if(messages.length > 1)
		showMessage(messages[messages.length-2]);	
	if(messages.length == 1)
		hideMessage();
	
	messages.pop();
	
	if(messages.length > 0 && messages[messages.length-1].html == null)
		$$displayed('messageScreen', false);
}

function removeMessage(id)
{
	var index = getMessageIndexById(id);
	if(index < 0) return;
	var message = messages[index];
	
	$("buttons").innerHTML = "";
	$$html("message", "");
	
	if(index == messages.length-1 && messages.length > 1)
		showMessage(messages[messages.length-2]);
	
	messages.splice(index, 1);
	
	if(messages.length > 0 && messages[messages.length-1].html == null)
		$$displayed('messageScreen', false);
	
	if(messages.length == 0)
		hideMessage();
}

function showMessage(message)
{
	buttonDiv = document.createElement("div");
	for(i = 0; message.buttons != null && i < message.buttons.length; i++)
	{		
		var button = document.createElement("img");
		button.setAttribute("src", (message.buttons[i])["src"]);
		button.setAttribute("title", message.buttons[i]["title"]);
		button.setAttribute("class", "button");
		
		if(message.buttons[i]["id"])
			button.setAttribute("id", message.buttons[i]["id"]);
				
		//closures...crazy hackery?  or brilliance?
		if(message.buttons[i]["hover"])
		{
			button.onmouseover = createClosure(function(args){ this.src = args[0] } , [message.buttons[i]["hover"]]);
			button.onmouseout  = createClosure(function(args){ this.src = args[0] } , [message.buttons[i]["src"]]);
		}
		else
		{
			//special case iPod button
			button.onmouseover = mouseOverIpod;
			button.onmouseout = mouseOutIpod;
		}
		button.onclick = createEvalClosure(message.buttons[i]["action"]);
		
		buttonDiv.appendChild(button);
	}
	
	$("buttons").innerHTML = '';
	$("buttons").appendChild(buttonDiv);
	$$html('message', message.html);
	$$displayed('message', true);
	
	if(message.html) $$displayed('messageScreen', true);
}

function hideMessage()
{
	$("buttons").innerHTML = "";
	$$displayed('messageScreen', false);
	$$displayed('message', false);
	$$html('message', '');
}

function clearMessages()
{	
	hideMessage();
	messages = new Array();
}


function getMessageById(id)
{
	for(i = 0; i < messages.length; i++)
		if(messages[i].id == id) return messages[i];
	
	return null;
}

function getMessageIndexById(id)
{
	for(i = 0; i < messages.length; i++)
		if(messages[i].id == id) return i;
		
	return -1;
}

////////////////////////////////////////////////////////////////////////////
function mouseOutIpod()
{
	if($('ipod_button'))
	{
		if(isDownloading(cuedVideo.id))
			$('ipod_button').src='Images/cancel.gif'
		else
			$('ipod_button').src='Images/itunes.png'	
		}
}

function mouseOverIpod()
{	
	if($('ipod_button'))
	{
		if(isDownloading(cuedVideo.id))
			$('ipod_button').src='Images/cancel_over.gif'
		else
			$('ipod_button').src='Images/itunes_over.png'	
	}
}

function clickIpod()
{
	if(isDownloading(cuedVideo.id))
	{
		clearDownload(cuedVideo.id);
		return;
	}
	
	if($('ipod_button'))
		$('ipod_button').src='Images/cancel.gif'
	
	cuedVideo.download();	
}

function isDownloading(id)
{
	if(!downloadingVideos) return false;
	
	for(i = 0; i < downloadingVideos.length; i++)
		if(downloadingVideos[i].id == id) return true;
	
	return false;
}

function popupChanged(event) 
{
	var type = (event.target.id).match(/.*_/);
	document.getElementById(type + "label").innerText = event.target.options[event.target.selectedIndex].innerText;
}

function browse_popupHandler(value)
{
	onFlipToFront = null;
	
	var searchfield = document.getElementById("searchfield");
	var urlfield = document.getElementById("urlfield");
	var codefield = document.getElementById("codefield");
	var browser = document.getElementById("browser");
	var subs_browser = document.getElementById("subs_browser");
	var dimmer = document.getElementById("dimmer");
	
	var time_label = document.getElementById("time_label");
	var time_popup = document.getElementById("time_popup");
	var category_label = document.getElementById("category_label");
	var category_popup = document.getElementById("category_popup");
	
	urlfield.style.display = "none";
	codefield.style.display = "none";
	//searchfield.style.display = "none";
	dimmer.style.display = "none";
	browser.style.display = "none";
	subs_browser.style.display = "none";
	time_label.style.display = "none";
	time_popup.style.display = "none";
	category_label.style.display = "none";
	category_popup.style.display = "none";
	
	subscription_label.style.display = "none"; //exp
	subscription_popup.style.display = "none"; //exp
	playlist_label.style.display = "none"; //exp
	playlist_popup.style.display = "none"; //exp
	
	if(value.substr(0,3) == "All")
	{
		searchfield.title = "Search" + value.substring(3).toLowerCase();
		dimmerTarget = searchfield;
		dimmer.style.display = "block";
		searchfield.style.opacity = "1";
		searchfield.style.display = "block";
		searchfield.focus();
		searchfield.select();
	} else if(value == "Paste Link")
	{
		dimmerTarget = urlfield;
		urlfield.style.display = "block";
		urlfield.focus();
		urlfield.select();
	} else if(value.substr(0,2) == "My")
	{
		if(value.match(/downloads/i))
		{
			if(isPlaying) stopVideo();
			
			nextPage = "";
			videos = downloadingVideos;
			renderVideoGuide(downloadingVideos, true, "Downloads", downloadingVideos.length + " video" + ((downloadingVideos.length == 1) ? "" : "s") + " currently downloading");
			return;
		}
		
		//why doesn't display = "none" work cleanly here?
		searchfield.style.opacity = "0";
		clearMessages();
		hideVideoInfo();
		username = document.getElementById("userfield").value;
		
		if(username)
		{
			if(value.match(/subscriptions/i))
			{
				subscription_label.style.display = "block"; //exp
				subscription_popup.style.display = "block"; //exp
				subs_browser.style.display = "block";
				$("browse_label").innerText = "Subscriptions";
				$("subscription_label").innerText = "Select a subscriptions";
				
				fetchMySubscriptions(username);
			}
			else if(value.match(/playlists/i))
			{
				playlist_label.style.display = "block"; //exp
				playlist_popup.style.display = "block"; //exp
				subs_browser.style.display = "block";
				$("browse_label").innerText = "Playlists";
				$("subscription_label").innerText = "Select a playlist";
				
				fetchMyPlaylists(username);
			} else
				setTimeout("fetchMy" + value.substr(3) + "('" + username + "')", 0);
		} else
		{
			showBack(null);
			onFlipToFront = value;
			document.getElementById("userfield").focus();
		}
	} else if(value == "Enter Code")
	{
		dimmerTarget = codefield;
		codefield.style.display = "block";
		codefield.focus();
		codefield.select();
	} else if(value == "More Info")
	{
		widget.openURL("http://www.interdimensionmedia.com/widgets/mytube/donate.html");
	} else
	{		
		clearMessages();
		
		browser.style.display = "block";
		time_label.style.display = "block";
		time_popup.style.display = "block";
		category_label.style.display = "block";
		category_popup.style.display = "block";
		
		browse();
	}
	
	if(value == "Featured" || value == "Most Recent")
	{
		document.getElementById("time_label").innerText = "Recently";
		time_popup.style.display = "none";
	} else {
		document.getElementById("time_label").innerText = document.getElementById("time_popup").value;
	}
}

function browse()
{
	browse_popup = document.getElementById("browse_popup");
	time_popup = document.getElementById("time_popup");
	category_popup = document.getElementById("category_popup");
	language_popup = document.getElementById("language_popup");

	list = browse_popup.options[browse_popup.selectedIndex].id;
	timeframe = time_popup.options[time_popup.selectedIndex].id;
	category = category_popup.options[category_popup.selectedIndex].id;
	language = language_popup.options[language_popup.selectedIndex].id;

	fetchListedVideos(list, timeframe, category, language);
}

function handleAction(event) 
{
	if(cuedVideo)
	{
		switch(event.target.selectedIndex)
		{
			case 1: cuedVideo.viewInBrowser();
			break;
			case 2: cuedVideo.shareWithFriends();
			break;
			case 3: cuedVideo.postToDelicious();
			break;
			case 4: fetchRelatedVideos(cuedVideo);
			break;
			case 5: fetchResponseVideos(cuedVideo);
			break;
			case 6: if(isPlaying) toggleFullscreen();
			break;
			case 7: cuedVideo.copyURL();
			break;
			case 8: cuedVideo.copyHTML();
			break;
			case 9:cuedVideo.download();
			break;
		}
	
	} else myTubePlugin.beep();
	
	document.getElementById("gear_combo").options[0].selected = true;
}

function donate(event)
{
	if(window.widget) widget.openURL("http://www.interdimensionmedia.com/widgets/mytube/donate.html");
}

function setPreference(pref, key) 
{
	if(window.widget) widget.setPreferenceForKey(pref, key);
}

function loadPreferences()
{	
	$("codefield").value = widget.preferenceForKey("codefield") ? widget.preferenceForKey("codefield") : "";
	$("userfield").value = widget.preferenceForKey("userfield") ? widget.preferenceForKey("userfield") : "";
	$("passwordfield").value = widget.preferenceForKey("passwordfield") ? widget.preferenceForKey("passwordfield") : "";
	$("language_popup").selectedIndex = widget.preferenceForKey("language_popup");
	$("leaving_popup").selectedIndex = widget.preferenceForKey("leaving_popup");
	$("leaving_popup").selectedIndex = widget.preferenceForKey("leaving_popup");
	$("fs_checkbox").checked = widget.preferenceForKey('fs_checkbox');
	
	fs_size = widget.preferenceForKey("fs_size");
	if(fs_size == null) fs_size = 3;
	
	video_smoothing = widget.preferenceForKey("video_smoothing");
	if(video_smoothing == null) video_smoothing = 'true';

	//restore widget position when fullscreen mode doesn't exit cleanly
	var x = widget.preferenceForKey("screenX")*1;
	var y = widget.preferenceForKey("screenY")*1;
	if(x && y) widget.resizeAndMoveTo(x, y, 297, 277);
	
	//set logging prefs
	logging = widget.preferenceForKey('logging');
	if(logging) log(name + " logging on");
}

//extending basic string functionality ---------------------------------------

String.prototype.toTitleCase = function()
{
	var str = this.toLowerCase(),
	newStr = '';

	for ( var i = 0, l = str.length; i < l; i++ )
	{
	newStr += ( i == 0 || str.charAt( i - 1 ) == ' ' )?
	str.charAt( i ).toUpperCase():
	str.charAt( i );
	}
	return newStr;
}

String.prototype.expandHtmlEntities = function()
{
	var div = null;
	var result = "";
	
	div = document.createElement("div");
	if(typeof div.innerHTML!="undefined" && typeof div.firstChild!="undefined")
	{
		result = this.valueOf().replace(/&[a-z0-9#]+;/gi, function(a){ return div.innerHTML=a, div.firstChild.nodeValue; } );
	}

	return result;
}

//automatic update check functionality ---------------------------------------

HOURLY = 1000*60*60;
DAILY = HOURLY*24;
WEEKLY = DAILY*7;

updateCheckInterval = WEEKLY;
lastUpdateCheck = 0;
updateReq = null;
videoInfoShown = false;

function handleUpdateResponse()
{
	if(updateReq.readyState == 4 && updateReq.status == 200)
    {
    	latestVersion = updateReq.responseText;

		if(latestVersion)
		{
			if(version < latestVersion && !isPlaying)
			{
				var HTML = "<font color='#FFF' size='5px'>myTube " + latestVersion + "<br></font>update now available";
				
				pushMessage('update', HTML, [
					{"title":"Remind me later", "src":"Images/later.png", "hover":"Images/later_over.png", "action":"popMessage();"},
					{"title":"Visit download site", "src":"Images/update.png", "hover":"Images/update_over.png", "action":"popMessage();widget.openURL('http://www.interdimensionmedia.com/widgets/?widget=mytube');"}
				]);
			}
		}
	}
}

function checkForUpdate()
{
	var currentTime = (new Date).getTime();
	if(currentTime - lastUpdateCheck < updateCheckInterval || isPlaying) return;
	lastUpdateCheck = currentTime;

    updateReq = new XMLHttpRequest();
    url = "http://www.interdimensionmedia.com/widgets/widgetversion.php?widget=" + name;
	updateReq.open("GET", url, true);
	updateReq.onreadystatechange = handleUpdateResponse;
	updateReq.send(null);
}

function hideUpdateInfo(moreInfo)
{
		if(moreInfo) widget.openURL('http://www.interdimensionmedia.com/widgets/?widget=' + name);
		popMessage('update');
}

// automatic parser patch --------------------------------------------------

patchCheckInterval = WEEKLY;
lastPatchCheck = 0;

function checkForPatch()
{
	var currentTime = (new Date).getTime();
	if(currentTime - lastPatchCheck < patchCheckInterval) return;
	
	lastPatchCheck = currentTime;
	reloadScript("http://www.interdimensionmedia.com/widgets/mytube/source/parser.js");
}

function reloadScript(url)
{
	var head = document.getElementsByTagName("head");
	
	var script = document.createElement("script");
	script.src = url + "?" + Math.random();
	script.type="text/javascript";
	
	re = new RegExp(url);
	
	for(i = 0; i < head[0].childNodes.length; i++)	
		if(re.test(head[0].childNodes[i].src))
			head[0].removeChild(head[0].childNodes[i--]);
	
	document.getElementsByTagName("head")[0].appendChild(script);
}

//a debugging log function for writing information to console ----------------
//this function can be toggled on and off with command-shift-D

var logging = false;

function log(message)
{
	if(logging) alert(message);
}

function toggleLogging()
{
	logging = !logging;
	widget.setPreferenceForKey(logging, "logging");
	alert(name + " debugging " + ((logging) ? 'on' : 'off'));
}