var flashMovie = window.document["movieObject"];
var playingVideo = null;
var cuedVideo = null;
var keepAwakeTimer = null;
var controlTimer = null;
var launch_fullscreen;
var video_smoothing = true;

function playVideo(video, fs)
{
	spinner.start();
	clearMessages();
	
	if(isPlaying) stopVideo();
	cuedVideo = playingVideo = video;
	
	stopScrolling();
	hideVideoInfo();
	
	$("play_pause").src = "Images/pause.png";
	$('fs_play_pause').src = "Images/fs_pause.png";
	paused = false;
	
	launch_fullscreen = fs;
	
	video.updateTrackID(video, initiatePlayback);	
}

function initiatePlayback()
{
	if(spinner) spinner.stop();
	
	var url = 'Components/tube.swf?video_id=' + playingVideo.id + "&t=" + playingVideo.track_id + "&set_volume=" + volume + "&video_smoothing=" + video_smoothing + "&code=" + $value('codefield');
	var object = "<object id='movieObject' width='100%' height='100%'><param name='movie' value='" + url + "'>\</param><param name='wmode' value='transparent'><embed id='videoEmbed' src= " + url + " type='application/x-shockwave-flash' width='100%' height='100%' bgcolor='#000000' align='middle'></embed></object>";
	$("video_screen").innerHTML = object;
	
	$$displayed('video_screen', 'true');
	 
	flashMovie = window.document["movieObject"];
	if(!flashMovie) flashMovie = window.document.all["movieObject"];
	
	flashMovie.onclick = function() { toggleFullscreen(); if(flashMovie) flashMovie.blur(); $('browse_popup').focus(); };
	
	progressUpdateID = setTimeout("updateVideoProgress()", Math.max(0, (playingVideo.length-1)*1000));
	
	isPlaying = true;
	
	if(keepAwakeTimer) clearInterval(keepAwakeTimer);
	keepAwakeTimer = setInterval("keepAwake();", 30000);
	
	if($checked('fs_checkbox') || launch_fullscreen) toggleFullscreen();
}

function stopVideo()
{
	toggleFullscreen(1);
	
	$('progress_bar').style.width = '0px';
	$('loading_bar').style.width = '0px';
	$$text('time_display', '00:00');
	$("play_pause").src = "Images/play.png";
	$('fs_play_pause').src = "Images/fs_play.png";
	
	isPlaying = false;
	if(cuedVideo) showVideoInfo();
	
	document.getElementById("video_screen").innerHTML = "";
	flashMovie = null;
	clearInterval(progressUpdateID);
	
	if(keepAwakeTimer) clearInterval(keepAwakeTimer);
	keepAwakeTimer = null;
}

function playCuedVideo(fs)
{
	playVideo(cuedVideo, fs);
}

function cueVideo(video)
{
	cuedVideo = video;
}

var paused = false;
function togglePlayback(e)
{	
	if(isPlaying)
	{
		paused = !paused;
		if(flashMovie) flashMovie.SetVariable("_root:toggle_pause", paused + '');
		$$src('play_pause', (paused) ? "Images/play.png" : "Images/pause.png");
		
		var over = "";
		if($src('fs_play_pause').match(/over/)) over = "_over";
		$$src('fs_play_pause', (paused) ? ("Images/fs_play" + over + ".png") : ("Images/fs_pause" + over + ".png"));
		
		if(e && e.altKey) toggleFullscreen();
		
	} else
	{
		if(cuedVideo)
		{
			playVideo(cuedVideo, (e) ? e.altKey : null);
			isPlaying = true;
			$("play_pause").src = "Images/pause.png";
		}
	}
}

function pause()
{
	if(isPlaying && !paused)
	{
		paused = true;
		if(flashMovie) flashMovie.SetVariable("_root:toggle_pause", "true");		
	}
}

function unpause()
{
	if(isPlaying && paused)
	{
		paused = false;
		if(flashMovie) flashMovie.SetVariable("_root:toggle_pause", "false");
	}
}

var fullscreen = false;
var windowX = null;
var windowY = null;
var fs_size = 3;
var fullW;
var fullH;

function toggleFullscreen(size)
{
	if(size == null) fullscreen = !fullscreen;
	if(size == 1) fullscreen = false;
	if(size != null && size != 1) fullscreen = true;
	
	if(controlTimer) clearTimeout(controlTimer);
	controlTimer = null;
	
	if(fullscreen)
	{
		var offset = (size == 0 || size == null && fullW == null) ? 0 : 20;

		
		if(windowX == null)
		{
			windowX = window.screenX;
			windowY = window.screenY;
			
			setPreference(screenX, "screenX");
			setPreference(screenY, "screenY");
		}
		
		if(size != null)
		{
			fs_size = size;
			setPreference(size, "fs_size");
		}
		
		switch(fs_size)
		{
			case 2: fullW = 320; fullH = 240; break;
			case 3: fullW = 640; fullH = 480; break;
			case 4: fullW = 800; fullH = 600; break;
			//case 0: fullW = screen.width; fullH = screen.height; hideFSControls(); break;
			case 5: fullW = (screen.height-100)*1.333; fullH = (screen.height-100); break;
			case 0: fullW = screen.width; fullH = screen.height; hideFSControls(); break;
		}
		
		$$displayed('overlays', false);
		$$displayed('underlays', false);
		
		$("video_screen").style.width = screen.width + 'px';
		$("video_screen").style.height = screen.height + 'px';
		$("video_screen").style.top = '0px';
		$("video_screen").style.background = "#000";
		
		$("movieObject").style.width = fullW+'px';
		$("movieObject").style.height = fullH+'px';
		$("movieObject").style.left = (screen.width/2 - fullW/2) + 'px';
		$("movieObject").style.top = (screen.height/2 - fullH/2) + 'px';

		widget.resizeAndMoveTo(0, 0, screen.width, screen.height);
		$$displayed('fs_controls', true);
		
	} else {
		
		showCursor();
		$$displayed('fs_controls', false);
		
		if($("movieObject"))
		{
			$("movieObject").style.width = '245px';
			$("movieObject").style.height = '184px';
			$("movieObject").style.left = '25px';
			$("movieObject").style.top = '16px';
		}
		
		$("video_screen").style.width = '0px';
		$("video_screen").style.height = '0px';
		$("video_screen").style.background = "none";
		
		$$displayed('overlays', true);
		$$displayed('underlays', true);
		
		if(windowX && windowY) widget.resizeAndMoveTo(windowX, windowY, 297, 277);
		windowX = windowY = null;
		setPreference(null, "screenX");
		setPreference(null, "screenY");
	}
}

function updateVideoProgress()
{
	if(flashMovie != null)
	{
		var curr_time = flashMovie.GetVariable('_root:curr_time');
		var total_time = flashMovie.GetVariable('_root:total_time');
		var video_started = (total_time > 0) ? flashMovie.GetVariable('_root:video_started') : '';
		var video_ended = (total_time > 0) ? flashMovie.GetVariable('_root:video_ended') : '';
		var percent_loaded = flashMovie.GetVariable('_root:percent_loaded');
		var time_left = total_time - curr_time;
		var progress = curr_time/(total_time - .5);
		
		playingVideo.length = formatTime(total_time);
		
		var time_left = formatTime(time_left);
		
		$$text('time_display', time_left);
		$$text('fs_time_display', time_left);

		if(video_ended)
			setTimeout(stopVideo, 1000);
		else
		{
			if(video_started)
			{
				$('progress_bar').style.width = progress*141 + 'px';
				$('loading_bar').style.width = percent_loaded*141 + 'px';
				
				$('fs_progress_bar').style.width = progress*(screen.width-300) + 'px';
				$('fs_loading_bar').style.width = percent_loaded*(screen.width-300) + 'px';
			}
			progressUpdateID = setTimeout("updateVideoProgress()", 100);
		}
	}
}

var volume = 100;
var attenuated = false;

function increaseVolume() {
	if(flashMovie) flashMovie.SetVariable("_root:adjust_volume", "10");
	volume = Math.min(100, volume + 10);
}

function decreaseVolume() {
	if(flashMovie) flashMovie.SetVariable("_root:adjust_volume", "-10");
	volume = Math.max(0, volume - 10);
}

function maxVolume() {
	if(flashMovie) flashMovie.SetVariable("_root:set_volume", "100");
	volume = 100;
}

function minVolume() {
	if(flashMovie) flashMovie.SetVariable("_root:set_volume", "0");
	volume = 0;
}

function attenuateVolume() {
	if(flashMovie)
	{
		attenuated = !attenuated;
		if(attenuated) flashMovie.SetVariable("_root:set_volume", "" + volume*.15);
		else flashMovie.SetVariable("_root:set_volume", "" + volume);
	}
}

function rewind() {
	if(flashMovie) flashMovie.SetVariable("_root:seek_to", "0");
}

function jumpBack() {
	if(flashMovie) flashMovie.SetVariable("_root:seek_by", "-15");
}

function jumpAhead() {
	if(flashMovie) flashMovie.SetVariable("_root:seek_by", "15");
}

function seekTo(percent) {
	if(flashMovie) flashMovie.SetVariable("_root:seek_to", "" + percent*100);
}

function formatTime(secs)
{
	if(secs >= 0) ; else return '00:00';
	
	secs = Math.round(secs);
	var minutes = Math.floor(secs/60);
	
	var seconds = secs;
	if(minutes != 0) seconds = seconds - (minutes*60);
	
	if(minutes < 10) minutes = '0' + minutes;
	if(seconds < 10) seconds = '0' + seconds;
	
	return minutes + ':' + seconds;
}

var scrubbing = false;
var scrubPause = false;

document.captureEvents(Event.MOUSEUP);

document.onmouseup = function() {
	stopScrubbing();
}

function startScrubbing(fs)
{
	scrubbing = true;
	if(!paused) 
	{
		scrubPause = true;
		pause();
	}
	scrub(fs);
}

function stopScrubbing(fs)
{
	if(scrubbing)
	{
		scrub(fs);
		if(scrubPause) unpause();
		scrubPause = false;
		scrubbing = false;
	}
}

function scrub(fs) {
	
	if(fs) seekTo((mouseX - 200)/(screen.width - 300));
	else seekTo((mouseX - 65)/150);
}

function keepAwake() {
	if(!paused) myTubePlugin.keepAwake();
}

function hideCursor() {
	if(!dashboardHidden)
	{
		//alert("cursor hidden");
		cursorShown = false;
		myTubePlugin.hideCursor();
	}
}

function showCursor() {
	if(!cursorShown)
	{
		//alert("cursor shown");
		cursorShown = true;
		myTubePlugin.showCursor();
	}
}

function showFSControls()
{
	if(fs_size == 0) return;
	
	showCursor();
	$('fs_controls').style.opacity = 1;
	$$displayed('fs_controls', true);
	$('fs_controls').style.bottom = "0px";
	
	if(controlTimer) clearTimeout(controlTimer);
	controlTimer = setTimeout(fadeFSControls, 2000);
}

function fadeFSControls()
{
	if(controlTimer) clearTimeout(controlTimer);
	
	var opacity = $('fs_controls').style.opacity*1 - .1;
	$('fs_controls').style.opacity = opacity;
	
	if(opacity > 0)
		controlTimer = setTimeout(fadeFSControls, 40);
	else if(!dashboardHidden)
		hideCursor();
}

function hideFSControls()
{
	hideCursor();
	$$displayed('fs_controls', false);
	$('fs_controls').style.bottom = "-50px";
}

function rollover_fs_play_pause() {
	$$src('fs_play_pause', (paused) ? "Images/fs_play_over.png" : "Images/fs_pause_over.png");
}

function rollout_fs_play_pause() {
	$$src('fs_play_pause', (paused) ? "Images/fs_play.png" : "Images/fs_pause.png");
}

function rollover_fs_exit() {
	$$src('fs_exit', "Images/fs_exit_over.png");
}

function rollout_fs_exit() {
	$$src('fs_exit', "Images/fs_exit.png");
}
