// This file contains utlility functions provided by the Textmate Widget 
// Bundle that make coding Dashboard widgets more efficient.
//
// Do not remove anything from this file, as many of the snippets and
// commands in the Textmate Widget Bundle depend upon these functions.
// You may extend this file with additional utility functions if you wish.


//quick and succinct accessor functions for common HTML elements & properties
function $(id) 				{ return document.getElementById(id); }
function $value(id) 		{ return $(id).value; }
function $checked(id) 		{ return $(id).checked ? true : false; }
function $text(id) 			{ return $(id).innerText; }
function $html(id) 			{ return $(id).innerHTML; }
function $src(id) 			{ return $(id).src; }
function $title(id) 		{ return $(id).title; }
function $displayed(id) 	{ return $(id).style.display == 'block'; }
function $enabled(id) 		{ return !$(id).disabled; }
function $selected(id) 		{ return $(id).selected}
function $selectedIndex(id)	{ return $(id).selectedIndex; }
function $selectedText(id) 	{ return $(id).options[$(id).selectedIndex].text; }
function $selectedValue(id) { return $(id).options[$(id).selectedIndex].value; }

//quick and succinct setter functions for common HTML elements & properties
function $$value(id, value) 		{ $(id).value = value; }
function $$checked(id, checked) 	{ $(id).checked = checked ? 'checked' : ''; }
function $$text(id, text) 			{ $(id).innerText = text; }
function $$html(id, html) 			{ $(id).innerHTML = html; }
function $$src(id, url)				{ $(id).src = url; }
function $$title(id, title) 		{ $(id).title = title; }
function $$displayed(id, bool) 		{ $(id).style.display = (bool) ? 'block': 'none'; }
function $$enabled(id, bool) 		{ $(id).disabled = !bool; }
function $$selected(id, bool) 		{ $(id).selected = bool; }
function $$selectedIndex(id, index)	{ $(id).selectedIndex = index; }
function $$selectedText(id, text) 	{ $(id).options[$(id).selectedIndex].text = text; }
function $$selectedValue(id, value) { $(id).options[$(id).selectedIndex].value = value; }

// returns the localized string from the language project directory for
// the users preferred language, if it exists, the argument string otherwise
function getLocalizedString(string)
{
	try { string = localizedStrings[string] || string; } catch (e) {}
	return string;
}


// used to create the default 'Done' button on the backside of the widget
// you can call this function yourself to create additional buttons
function CreateGlassButton(buttonID, spec)
{
	var buttonElement = document.getElementById(buttonID);

	if (!buttonElement.loaded) {
		buttonElement.loaded = true;

		var text = spec.text || '';
		if (window.getLocalizedString) text = getLocalizedString(text);

		var onclick = spec.onclick || null;
		try { onclick = eval(onclick); } catch (e) { onclick = null; }

		buttonElement.object = new AppleGlassButton(buttonElement, text, onclick);
		buttonElement.object.setEnabled(!spec.disabled);
	}

	return buttonElement.object;
}

// used to create the default 'Info' button on the frontside of the widget
function CreateInfoButton(flipperID, spec)
{
	var flipElement = document.getElementById(flipperID);

	if (!flipElement.loaded) {
		flipElement.loaded = true;

		var onclick = spec.onclick || null;
		try { onclick = eval(onclick); } catch (e) { onclick = null; }

		flipElement.object = new AppleInfoButton(flipElement, document.getElementById(spec.frontID), spec.foregroundStyle, spec.backgroundStyle, onclick);
	}

	return flipElement.object;
}

