downloadingVideos = new Array();

function Video()
{
	this.id = "";
	this.title = "";
	this.length = "--:--";
	this.user = "";
	this.rating = 0;
	this.ratings = 0;
	this.views = 0;
	this.favorited = 0;
	this.comments = 0;
	this.description = "-";
	this.imageURL = "";
	this.track_id = "";
	this.year = "-";
	this.url = "";
	
	this.viewInBrowser = viewInBrowser;
	this.shareWithFriends = shareWithFriends;
	this.postToDelicious = postToDelicious;
	this.viewVideoInfo = viewVideoInfo;
	this.viewRelatedVideos = viewRelatedVideos;
	this.saveToFavorites = saveToFavorites;
	this.copyURL = copyURL;
	this.copyHTML = copyHTML;
	this.updateTrackID = updateTrackID;
	this.download = download;
	this.print = print;
	this.updateDownloadState = updateDownloadState;
	
	function viewInBrowser()
	{
		widget.openURL("http://youtube.com/watch?v=" + this.id);
	}
	
	function shareWithFriends()
	{
		widget.openURL("http://youtube.com/share?v=" + this.id);
	}
	
	function postToDelicious()
	{
		widget.openURL("http://del.icio.us/post?v=3&url=" + encodeURIComponent("http://youtube.com/watch?v=" + this.id) + "&title=" + encodeURIComponent(this.title));
	}
	
	function viewVideoInfo() {;}
	function viewRelatedVideos() {;}
	function saveToFavorites() {;}
	
	function copyURL()
	{
		var url = "http://youtube.com/watch?v=" + this.id
		widget.system("/bin/echo -n '" + url + "' | /usr/bin/pbcopy", null);
	}
	
	function copyHTML()
	{
		var html = "<object width='425' height='350'><param name='movie' value='http://www.youtube.com/v/" + this.id + "'></param><param name='wmode' value='transparent'></param><embed src='http://www.youtube.com/v/" + this.id + "' type='application/x-shockwave-flash' wmode='transparent' width='425' height='350'></embed></object>";
		
		widget.system("/bin/echo -n \"" + html + "\" | /usr/bin/pbcopy", null);
	}
	
	function updateTrackID(video, handler)
	{
		//var tidReq = new XMLHttpRequest();
		var tidReq = null;
		
		//tidReq.onload = function() {
		var parseTID = function() {
			
			//var HTML = tidReq.responseText;
			var HTML = tidReq.outputString;
			
			theMatch = HTML.match(/content.*flagged/i);
			if(theMatch)
			{
				postLoginHandler = function() { updateTrackID(video, handler); }
				
				logIn(video.id);
				return;
			}
			
			theMatch = HTML.match(/type\s*=\s*submit.*value\s*=\s*"Confirm/i);
			if(theMatch)
			{	
				pushMessage('flagged', "<font color='#FFF' size='5px'>Flagged Video<br></font>Not yet supported.  Please launch this video in the browser.", 
				[
					{"title":"Return to guide", "src":"Images/guide.png", "hover":"Images/guide_over.png", "action":"popMessage();showVideoInfo();"},
					{"title":"View in browser", "src":"Images/launch.png", "hover":"Images/launch_over.png", "action":"popMessage();showVideoInfo(); cuedVideo.viewInBrowser();"}
				]);
				clearDownload(video.id);
				return;
			}
			theMatch = HTML.match(/class\s*=\s*\"errorBox\"\>\s*([^<]*)\s*/mi)
			if(theMatch)
			{
				pushMessage('removed', "<font color='#FFF' size='4px'>Video Unavailable<br></font>" + theMatch[1],
				[
					{"title":"Return to guide", "src":"Images/guide.png", "hover":"Images/guide_over.png", "action":"popMessage();showVideoInfo();"}
				]);
				clearDownload(video.id);
				return;
			}
			
			theMatch = HTML.match(/video_id=.*&t=([^&"]*)/i);
			video.track_id = (theMatch) ? theMatch[1] : '';
			
			//grab the description and absolute date, since we can
			var info = parseInfoSection(HTML);
				
			var desc = parseDescription(HTML);
			if(desc != "-") video.description = desc;
			
			if(info) video.year = parseYear(info);
			else video.year = new Date().getFullYear();
			
			handler.call(video, video);
		}
		
		var command = "curl -L -c /tmp/mytube_cookies -b /tmp/mytube_cookies 'http://youtube.com/watch?v=" + video.id + "'";
		tidReq = widget.system(command, parseTID);
		
		//tidReq.open("GET", "http://youtube.com/watch?v=" + video.id);
		//tidReq.send(null);
	}
	
	function download()
	{
		if(isDownloading(this.id))
		{
			log("(" + this.id + ") " + "ignoring duplicate download request...");
			return;
		}

		log("(" + this.id + ") " + "initiating flv download...");
		downloadingVideos.push(this);
		this.downloadState = "initializing";
		this.updateTrackID(this, getDownloadURL);
	}
	function getDownloadURL(video) {


		if(video.track_id == '')
		{
			clearDownload(video.id);
			return;
		}

		log("(" + video.id + ") " + "retreiving flv download url...");
		video.filename = video.title.replace(/<\S[^><]*>/g, "").expandHtmlEntities();
		video.safeFilename = video.filename.replace(/"/g, "\\\"").replace(/'/g, "\'").replace(/\//g, "|").replace(/:/r, " - ");
		
		username = video.user;
		description = video.description;
		year = video.year;
		
		video.url = myTubePlugin.getVideoURL(video.id, video.track_id, $value('codefield'));
		var exportsRemaining = video.url.charAt(0);
		video.url = video.url.substr(1, video.url.length - 1);
		video.url = video.url.replace(/\n/,""); //strip newline if present
		
		widget.system("/bin/mkdir -p ~/Movies/MyTube/Incomplete", null);
		
		if(exportsRemaining < 3)
		{
			var message = "";
			
			toggleFullscreen(1);
			if(isPlaying) stopVideo();
			
			switch(exportsRemaining)
			{
				case '2': message = exportsRemaining + " Exports Left"; break;
				case '1': message = exportsRemaining + " Export Left"; break;
				case '0': message = "Last Export"; break;
				default: message = "No Exports Left";
			}
			
			pushMessage('exports', "<font color='#FFF' size='5px'>" + message + "<br></font>Unlock the iPod export bonus feature with your donation of $1.99 or more.", 
			[
				{"title":"Remind me later", "src":"Images/later.png", "hover":"Images/later_over.png", "action":"popMessage();showVideoInfo();"},
				{"title":"Donate", "src":"Images/donate.png", "hover":"Images/donate_over.png", "action":"popMessage();widget.openURL('http://www.interdimensionmedia.com/widgets/mytube/donate.html');"}
			]);
		}
		
		if(video.url == "unregistered")
		{	
			toggleFullscreen(1);
			if(isPlaying) stopVideo();
			
			pushMessage('exports', "<font color='#FFF' size='5px'>Donate Today!<br></font>Unlock the iPod export bonus feature with your donation of $1.99 or more.", 
			[
				{"title":"Remind me later", "src":"Images/later.png", "hover":"Images/later_over.png", "action":"popMessage();showVideoInfo();"},
				{"title":"Donate", "src":"Images/donate.png", "hover":"Images/donate_over.png", "action":"popMessage();widget.openURL('http://www.interdimensionmedia.com/widgets/mytube/donate.html');"}
			]);
			clearDownload(video.id);
		} else if(video.url == "") {
			clearDownload(video.id);
			widget.system("osascript -e 'tell application \"Finder\" to display alert \"Export Error\" as warning message \"No valid download URL for the YouTube video \\\"" + video.safeFilename + ".flv\\\" could be found.\" buttons {\"OK\"}'", devnull);
		} else {
			
			command = "curl -L '" + video.url + "' -o \"$HOME/Movies/MyTube/Incomplete/" + video.safeFilename + ".flv\"";
			log(command);
			var downloadID = video.id;
			log("(" + downloadID + ") " + "downloading flv file from " + video.url + "...");
			log("(" + downloadID + ") " + command);
			video.updateDownloadState("downloading");
			video.downloadStep = widget.system(command, function() { convertDownload(downloadID); } );
		}
	}	
	function convertDownload(downloadID) {
		var video = getVideoByID(downloadID);
		
		if(video.downloadStep.errorString && !video.downloadStep.errorString.match(/100\s/i))
		{
			log("(" + downloadID + ") " + "DOWNLOAD ERROR: " + video.downloadStep.errorString);
			clearDownload(downloadID);
			dialogResult = widget.system("osascript -e 'tell application \"Finder\" to display alert \"Export Error\" as warning message \"An error occurred while downloading the YouTube video \\\"" + video.safeFilename + ".flv\\\". \n\nPlease click \\\"Download\\\" to attempt to retrieve the file through your browser.\" buttons {\"Cancel\", \"Download\"}'",
				function() { if(!dialogResult.outputString.match(/Cancel/i)) downloadViaBrowser(video.url); });
			return;
		}
		
		//ensure movies folder exists
		widget.system("/bin/mkdir -p ~/Movies/MyTube/Incomplete", null);
		
		var command = "Components/ffmpeg";
		var args = " -i ~/Movies/MyTube/Incomplete/\"" + video.safeFilename + ".flv\" -y -vcodec xvid -b 300 -qmin 3 -qmax 9 -bufsize 4096 -g 300 -acodec aac -ab 96 -s 320x240 -aspect 4:3 ~/Movies/MyTube/\"" + video.safeFilename + ".mp4\"";

		log("(" + downloadID + ") " + "download complete; converting downloaded flv...");
		video.updateDownloadState("converting");
		log("(" + downloadID + ") " + command + args);
		video.downloadStep = widget.system(command + args, function() { doneDownload(downloadID); } );
	}
	function doneDownload(downloadID) {
		var video = getVideoByID(downloadID);
		
		if(video.downloadStep.errorString && !video.downloadStep.errorString.match(/\[q\]/))
		{
			log("(" + downloadID + ") " + "CONVERSION ERROR: " + video.downloadStep.errorString);
			clearDownload(downloadID);
			
			if(video.downloadStep.errorString.match(/wasn't found/i))
				dialogResult = widget.system("osascript -e 'tell application \"Finder\" to display alert \"Export Error\" as warning message \"An error occurred while converting the YouTube video \\\"" + video.safeFilename + ".flv\\\" to mp4 format. \n\nPlease click \\\"Reveal\\\" to inspect the downloaded .flv file.\" buttons {\"Cancel\", \"Reveal\"}'",
					function() { if(!dialogResult.outputString.match(/Cancel/i)) revealFile(video.safeFilename, "flvs"); });
			else
				dialogResult = widget.system("osascript -e 'tell application \"Finder\" to display alert \"Export Error\" as warning message \"An error occurred while converting the YouTube video \\\"" + video.safeFilename + ".flv\\\" to mp4 format. \n\nPlease click \\\"Reveal\\\" to inspect the downloaded .flv file.\" buttons {\"Cancel\", \"Reveal\"}'",
					function() { if(!dialogResult.outputString.match(/Cancel/i)) revealFile(video.safeFilename, "flv"); });
			return;
		}
		
		log("(" + downloadID + ") " + "conversion complete; removing temporary files...");
		video.updateDownloadState("finalizing");
		widget.system("rm -f ~/Movies/MyTube/Incomplete/\"" + video.safeFilename + ".flv\"", null);
		
		log("(" + downloadID + ") " + "importing mp4 file...");
		log("(" + downloadID + ") " + "Components/addvideo \"" + video.safeFilename + ".mp4\" \"" + video.user + "\" \"" + video.year + "\" \"" + video.description + "\"");
		video.downloadStep = widget.system("Components/addvideo \"" + video.safeFilename + ".mp4\" \"" + video.user + "\" \"" + video.year + "\" \"" + video.description + "\"", function() { doneImport(downloadID); } );
	}
	function doneImport(downloadID) {
		
		var video = getVideoByID(downloadID);
		
		if(video.downloadStep.errorString)
		{
			log("(" + downloadID + ") " + "IMPORT ERROR: " + video.downloadStep.errorString);
			clearDownload(downloadID);
			if(video.downloadStep.errorString.match(/wasn't found/i))
				dialogResult = widget.system("osascript -e 'tell application \"iTunes\" to display alert \"Import Error\" as warning message \"An error occurred while importing the YouTube video \\\"" + video.safeFilename + ".flv\\\". \n\nPlease click \\\"Reveal\\\" to manually import the converted .mp4 file.\" buttons {\"Cancel\", \"Reveal\"}'",
					function() { if(!dialogResult.outputString.match(/Cancel/i)) revealFile(video.safeFilename, "mp4s"); });
			else
				dialogResult = widget.system("osascript -e 'tell application \"iTunes\" to display alert \"Import Error\" as warning message \"An error occurred while importing the YouTube video \\\"" + video.safeFilename + ".flv\\\". \n\nPlease click \\\"Reveal\\\" to manually import the converted .mp4 file.\" buttons {\"Cancel\", \"Reveal\"}'",
					function() { if(!dialogResult.outputString.match(/Cancel/i)) revealFile(video.safeFilename, "mp4"); });
			return;
		}
		
		if(widget.system('Components/growl \"' + video.safeFilename + '\"', null).outputString.match(/false/)) $('ding').Play();
		log("(" + downloadID + ") " + "mp4 import complete.");
		video.updateDownloadState("complete");
		clearDownload(downloadID);
	}
	
	function devnull(){;}
	
	function print()
	{
		alert("-----------------------------------------------------");
		alert(this.title + " (" + this.id + ")");
		alert("Posted by " + this.user + " " + this.date);
		alert(this.length);
		alert(this.rating + " stars (" + this.ratings + " ratings, " + this.views + " views)");
		alert(this.description);
		alert("-----------------------------------------------------");
	}
	
	return this;
}

function updateDownloadState(state)
{
	this.downloadState = state;
	
	log("guide: " + $('guide'));
	log("listing: " + $('guide').childNodes[i+2]);
	
	if(videos == downloadingVideos)
		for(i = 0; i < downloadingVideos.length; i++)
			if(downloadingVideos[i].id == this.id && $('guide').childNodes[i+2])
				$('guide').childNodes[i+2].childNodes[3].innerHTML = this.downloadState + "...";
}

function clearDownload(id)
{
	
	for(i = 0; i < downloadingVideos.length; i++)
	{
		if(downloadingVideos[i].id == id)
		{
			downloadingVideos.splice(i, 1);
			
			if(videos == downloadingVideos)
			{
				$('guide').removeChild($('guide').childNodes[i+2]);
				$('subheader').innerText = downloadingVideos.length + " video" + ((downloadingVideos.length == 1) ? "" : "s") + " currently downloading"
			
				if(downloadingVideos.length < 2) $('guide').scrollTop = 0;
			}
			
			break;
		}
	}
	
	if(cuedVideo && cuedVideo.id == id && $('ipod_button'))
		$$src('ipod_button', "Images/itunes.png");
	
	log("(" + id + ") " + "cleared download");
}

function downloadViaBrowser(url)
{
	log("opening url: " + url + "...");
	widget.openURL(url);
}

function revealFile(filename, format)
{
	if(format == "flv")
		widget.system("osascript -e  'tell application \"Finder\" to reveal ((path to movies folder as Unicode text) & \"MyTube:Incomplete:" + filename + ".flv\")'", null);
	else if(format == "mp4")
		widget.system("osascript -e  'tell application \"Finder\" to reveal ((path to movies folder as Unicode text) & \"MyTube:" + filename + ".mp4\")'", null);
	if(format == "flvs")
		widget.system("osascript -e  'tell application \"Finder\" to reveal ((path to movies folder as Unicode text) & \"MyTube:Incomplete:\")'", null);
	else if(format == "mp4s")
		widget.system("osascript -e  'tell application \"Finder\" to reveal ((path to movies folder as Unicode text) & \"MyTube:\")'", null);
	
	widget.system("osascript -e  'tell application \"Finder\" to activate'", null);
}

function getVideoByID(id)
{
	//if(videos)
	//	for(i = 0; i < videos.length; i++)
	//		if(videos[i].id == id) return videos[i];
	
	if(downloadingVideos)
		for(i = 0; i < downloadingVideos.length; i++)
			if(downloadingVideos[i].id == id) return downloadingVideos[i];
	
	if(droppedVideo)
		return droppedVideo
	
	return null;
}