var scrollTimer;
var scrollPosition = 0;

function renderVideoGuide(videos, showGuide, header, subheader)
{
	guide = $('guide');
	guide.innerHTML = "";
	guide.scrollTop = 0;
	scrollPosition = 0;
	
	var h = document.createElement("span");
	header = (header) ? header : "Video Listing";
	h.setAttribute("class", "header");
	h.innerHTML = "<br>" + header + "<br>";
	
	guide.appendChild(h);
	
	if(subheader)
	{
		var sh = document.createElement("span");
		sh.setAttribute("class", "subheader");
		sh.setAttribute("id", "subheader");
		sh.innerHTML = subheader + "<br>";
	
		guide.appendChild(sh);
	}
	
	if(!videos)
	{
		var listing = document.createElement("div");
		listing.setAttribute("class", "video");
		listing.setAttribute("id", "listing0");
		
		var error = document.createElement("div");
		//error.setAttribute("class", "title");
		//error.setAttribute("style", "padding-left: 15px");
		error.setAttribute("class", "error");
		error.innerHTML = "<br><br><br>No results found";

		listing.appendChild(error);
		guide.appendChild(listing);
	}
	else
	{
	
		for(var i = 0; i < videos.length; i++)
		{
			var video = videos[i];
		
			var listing = document.createElement("div");
			listing.setAttribute("class", "video");
			listing.setAttribute("id", "listing" + i);
			listing.setAttribute("title", video.views + "views, " + video.ratings + "ratings");
		
			var img = document.createElement("img");
			img.setAttribute("src", video.imageURL);
			img.setAttribute("width", 80);
			img.setAttribute("height", 60);
			img.setAttribute("class", "thumbnail");
			img.setAttribute("align", "left");
		
			var title = document.createElement("span");
			title.setAttribute("class", "title");
			title.innerHTML = video.title + "<br>";
		
			var length = document.createElement("span");
			length.setAttribute("class", "length");
			length.innerHTML = video.length + "<br>";
		
			listing.appendChild(img);
			listing.appendChild(title);
			listing.appendChild(length);
		
			if(isDownloading(video.id))
			{
				var state = document.createElement("span")
				state.setAttribute("class", "state");
				state.innerHTML = video.downloadState + "...";
				
				listing.appendChild(state);
				
				// var spin = document.createElement("im");
				// spin.setAttribute("src", "Images/cancel.gif");
				// spin.setAttribute("align", "right");
			} else {
				var stars = video.rating*1;
				for(var s = 0; s < stars; s++)
				{
					var star = document.createElement("img");
					star.setAttribute("src", "Images/star.png");
					star.setAttribute("width", 15);
					star.setAttribute("height", 15);
					star.setAttribute("align", "left");
			
					listing.appendChild(star);
				}
			}			

			guide.appendChild(listing);
		}
		
		var nav = document.createElement("div");
		nav.setAttribute("class", "video");

		var more = document.createElement("div")
		more.setAttribute("id", "more");
		more.innerHTML = "more";
		
		if(nextPage > 0)
			nav.appendChild(more);
			
		guide.appendChild(nav);
	}
	
	var space = document.createElement("span");
	space.innerHTML = "<br>";
	guide.appendChild(space);
	
	if(spinner) spinner.stop();
	
	if(showGuide || !isPlaying)
	{
		$$displayed('guide', true);
		hideVideoInfo();
		scrollTimeout = setTimeout("startScrolling();", 750);
	}
}

function startScrolling()
{
	$$displayed('guide', true);
	
	setTimeout("setScrollPosition();", 1);
	
	if(videos && !isPlaying)
	{
		if(!scrollTimer)
			scrollTimer = setInterval(scrollGuide, 50);
	}	
}

function setScrollPosition()
{
	$('guide').scrollTop = scrollPosition;
}

function stopScrolling()
{
	if($displayed('guide'))
		scrollPosition = $('guide').scrollTop;
	
	if(scrollTimer)
	{
		clearInterval(scrollTimer);
		scrollTimer = null;
	}
	$$displayed('guide', false);
}

function scrollGuide()
{
	if(!videos || isPlaying) return;
	
	if(Math.abs(scroll_offset) >= 1)
	{
		var d = (scroll_offset)*.1
		scroll_offset -= d;
		$('guide').scrollTop -= d;
	}
	
	for(var i = 0; i < videos.length; i++)
	{
		var listing = $('listing' + i);
		if(listing) listing.style.background = "#111";
	}
	
	if(mouseX && (mouseX < 35 || mouseX > 262)) return;
	if(mouseY && (mouseY < 20 || mouseY > 200)) return;
	
	if(mouseX && mouseX > 0 && !isPlaying)
	{
		if(mouseY < 55) $('guide').scrollTop -= Math.pow((55 - mouseY)/6, 2);
		if(mouseY > 160 && mouseY < 200) $('guide').scrollTop += Math.pow((mouseY - 160)/6, 2);
	}
	
	var offset = 1;
	if($('guide').childNodes[1].getAttribute("class") == "subheader") offset = 2;
	
	for(var i = 0; i < videos.length; i++)
	{
		var listing = $('guide').childNodes[i+offset];
		
		if(listing)
		{
			var listingY = findPos(listing)[1] - $('guide').scrollTop;
		
			if(listingY < mouseY && listingY + 70 > mouseY)
				listing.style.background = "#0D3570";
			else
				listing.style.background = "#111";
		}
	}
	
	var more = $('more');
	
	if(more)
	{
		moreY = findPos(more)[1] - $('guide').scrollTop;
		
		if(moreY < mouseY && moreY + 20 > mouseY)
			more.style.background = "#333";
		else
			more.style.background = "#111";
	}
	
}

function clearGuide()
{
	stopScrolling();
	
	guide = $('guide');
	guide.innerHTML = "";
	
	$$displayed('guide', false);
}

function selectListing(e)
{	
	if(mouseX && (mouseX < 35 || mouseX > 262)) return;
	if(mouseY && (mouseY < 20 || mouseY > 200)) return;
	
	if(isPlaying) toggleFullscreen();
	if(!videos || isPlaying || messages.length > 0) return;
	
	
	if(scrollTimeout) clearInterval(scrollTimeout);
	
	var listing;
	
	listing = $('listing0');
	
	listingY = findPos(listing)[1] - $('guide').scrollTop;
	
	if(mouseY < listingY || listingY == 0)
	{
		if($displayed('videoInfo')) playCuedVideo();
		else reloadGuide(true);
		return;
	}
	
	var offset = 1;
	if($('guide').childNodes[1].getAttribute("class") == "subheader") offset = 2;
	
	for(var i = 0; i < videos.length; i++)
	{
		var listing = $('guide').childNodes[i+offset];
		//listing = $('listing' + i);
		
		if(listing)
		{
			listingY = findPos(listing)[1] - $('guide').scrollTop;
		
			if(listingY < mouseY && listingY + 70 > mouseY)
			{
			
				if(e && e.metaKey)
				{
					playVideo(videos[i], (e && e.altKey));
				}
				else
				{
					cueVideo(videos[i]);
					showVideoInfo();
				}
			}
		}
	}
	
	var more = $('more');
	
	if(more)
	{
		moreY = findPos(more)[1] - $('guide').scrollTop;
		
		if(moreY < mouseY && moreY + 20 > mouseY)
			fetchMoreVideos();
	}
	
	stopScrolling();
}

function hideVideoInfo()
{	
	info = $('videoInfo');
	info.innerHTML = "";
	$$displayed('videoInfo', false);
	
	popMessage('info');
}

function showVideoInfo()
{
	if(!cuedVideo) return;

	info = $('videoInfo');
	info.innerHTML = "";
	info.scrollTop = 0;
	$$displayed('videoInfo', true);
	$$displayed('message', false);
	var video = cuedVideo;
	
	var h = document.createElement("div");
	h.setAttribute("class", "header");
	h.setAttribute("style", "font-size: 12px; padding-right: 40px; text-overflow:ellipsis; overflow:hidden; white-space:nowrap;");
	h.innerHTML = "<br>" + video.title + "<br>";
	
	var sh = document.createElement("div");
	sh.setAttribute("class", "subheader");
	sh.setAttribute("style", "font-size: 10px;");
	sh.innerHTML = video.user;

	info.appendChild(h);
	info.appendChild(sh);
	
	var listing = document.createElement("div");
	listing.setAttribute("class", "video");
	listing.setAttribute("id", "listing0");
		
	var img = document.createElement("img");
	img.setAttribute("src", video.imageURL);
	img.setAttribute("width", 100);
	img.setAttribute("height", 75);
	img.setAttribute("class", "thumbnail");
	img.setAttribute("align", "left");
	listing.appendChild(img);

	var length = document.createElement("span");
	length.setAttribute("class", "length");
	length.innerHTML = video.length + "<br>";
	listing.appendChild(length);
	
	var stars = video.rating*1;
	for(var s = 0; s < stars; s++)
	{
		var star = document.createElement("img");
		star.setAttribute("src", "Images/star.png");
		star.setAttribute("width", 14);
		star.setAttribute("height", 14);
		star.setAttribute("align", "left");
		
		listing.appendChild(star);
	}
	
	var views = document.createElement("span");
	views.setAttribute("class", "title");
	views.innerHTML = "<br>" + video.views + " views<br>";
	listing.appendChild(views);
	
	// var ratings = document.createElement("span");
	// ratings.setAttribute("class", "title");
	// ratings.innerHTML = (video.ratings != 0) ? video.ratings + " ratings<br>" : "Unrated";
	// listing.appendChild(ratings);
	
	// var desc = document.createElement("span");
	// desc.innerHTML = video.description;
	// desc.setAttribute("style", "font-size: 9px;");
	// listing.appendChild(desc);
	
	info.appendChild(listing);
	
	var ipod_src = 'Images/itunes.png';
	var ipod_hover = 'Images/itunes_over.png';
	if(isDownloading(cuedVideo.id))
	{
		ipod_src = 'Images/cancel.gif';
		ipod_hover = '';
	}
	
	pushMessage('info', null, [
		{"title":"Return to guide", "src":"Images/guide.png", "hover":"Images/guide_over.png", "action":"popMessage();hideVideoInfo();startScrolling();"},
		{"title":"Export for iPod", "id":"ipod_button", "src":ipod_src, "action":"clickIpod();"},
		{"title":"Launch in Browser", "src":"Images/launch.png", "hover":"Images/launch_over.png", "action":"cuedVideo.viewInBrowser();"},
		{"title":"Play video", "src":"Images/replay.png", "hover":"Images/replay_over.png", "action":"popMessage();hideVideoInfo();playCuedVideo(event.altKey);"}
	]);
}

function findPos(obj) {
	if(!obj) return [-100,-100];
	
	var curleft = curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	return [curleft,curtop];
}