   var search_delay_msecs = 450;
   var sms_limit = 160;
   var last_query = "";
   var any_change = false;
   var tty = "";
   var baseURL = "http://algoritmer.dk/widget/";
   var configURL = baseURL + "#config";
   var tooltip = null;
   var tooltip_delay_msecs = 500;
   var tooltip_fade_msecs = 35;
   var done_poll_msecs = 500;
   var dropdown = null;

   var content_delay_msecs = 700;
   var content_timer = null;

   // update check
   var version = "1.92";
   var checkURL = baseURL + "check.php?version=" + version;
   var updateURL = "";

   var log_dir = "Library:Application Support:emitSMS widget";
   var log_path = "$HOME/Library/Application Support/emitSMS widget";

   var dev_prefix = "/dev/tty.";
   function decorateDev(dev) {
	 // device names containg colon (for example phone:) should be passed right through.
	 if(dev.indexOf(":") >= 0) return dev;
	 return dev_prefix + dev;
   }

   // time between checks - these are not controlled by a timer, but the time is 
   // checked when widget is shown, as we shouldn't bother with updates when widget
   // isn't used.
   var msecs_per_hour = 3600 * 1000;
   var msecs_per_day = msecs_per_hour * 24;
   var msecs_after_download = msecs_per_day * 7; // don't update less than a week from last update
   var msecs_between_check_try = msecs_per_hour * 2; // try every few hours when check fails
   var msecs_between_check_done = msecs_per_day * 1; // try every day when check works, but found nothing new
   var msecs_between_check_new = msecs_per_day * 5; // try rarely when we found something and informed user
   
   // get preference trying both instance-specific setting and
   // global value for widget.
   function getConfig(name) {
     var v = widget.preferenceForKey(widget.identifier + "-" + name);
     return v != undefined ? v : widget.preferenceForKey(name);
   }
   
   // store preference both specifically for widget and globally.
   function setConfig(name, value) {
     widget.setPreferenceForKey(value, widget.identifier + "-" + name);
     widget.setPreferenceForKey(value, name);
   }
   
   var req = null;
   function request(url, ondone) {
     var onstatechange = function() {
       if(req.readyState < 4) return;
       if(req.status == 200) ondone();
     };

	 if(window.XMLHttpRequest) {
       req = new XMLHttpRequest();
       req.onreadystatechange = onstatechange;
       req.open("GET", url, true);
       req.send(null);
       return true;
     } 

     if(window.ActiveXObject) {
       req = new ActiveXObject("Microsoft.XMLHTTP");
       if(req) {
         req.onreadystatechange = onstatechange;
         req.open("GET", url, true);
         req.send();
         return true;
       }
     }

     req = null;
     alert("Error creating XMLHTTPRequest object");
	 return false;
   }
   
   function updateCheckDone() {
     // don't check again for a long time
     var now = (new Date()).getTime();
	 widget.setPreferenceForKey(now + msecs_between_check_done, 
		                        widget.identifier + "-" + "check_deadline");

     var action = req.responseXML.getElementsByTagName("action")[0].firstChild.data;
     if(action == "update") {
       updateURL = req.responseXML.getElementsByTagName("url")[0].firstChild.data;
       var msg = req.responseXML.getElementsByTagName("message")[0].firstChild.data;

       // display update button and text on backside
       setInfoHTML(msg);
       document.getElementById("debugCheckbox").style.display = "none";
       document.getElementById("updateButton").style.display = "block";
       widget.setPreferenceForKey(now + msecs_between_check_new, 
		                        widget.identifier + "-" + "check_deadline");
       showBack();
     }
   }

   function checkUpdates() {
     // we only try to check at predefined intervals, even when try failed.
     var now = (new Date()).getTime();
     var deadline = widget.preferenceForKey(widget.identifier + "-" + "check_deadline");
     if(deadline == undefined) {
		widget.setPreferenceForKey(now, widget.identifier + "-" + "check_deadline");
		return;
	 }
	
	 // is it time for new check?
	 if(now < deadline) return;

     // wait a short time for next check, if it fails (we rewrite this when it works)
	 widget.setPreferenceForKey(now + msecs_between_check_try, 
		                        widget.identifier + "-" + "check_deadline");
     request(checkURL, updateCheckDone);  
   }
   
   function debug(msg) {
    if(!document.getElementById("debug").checked) return;
    alert(msg);
   }

   function populateDevices() {
     var cmd = widget.system("ls -1 " + dev_prefix + "*", null);
     var res = cmd.outputString;
     if(res == undefined) res = "";
     
     // remove previous entries
     var e = document.getElementById("terminal");
     e.options.length = 0;
     e.add(new Option("choose port", ""));
     
     var devs = res.split("\n");
     for(var i = 0; i < devs.length; ++i) {
       var dev = devs[i];
       dev = dev.replace(dev_prefix, "");
       if(dev.length > 0) e.add(new Option(dev));
     }
     
     tty = getConfig("tty");
     if(tty == undefined) tty = "";
     else e.value = tty;
   }
 
   function search() {
	   var query = dropdown.unselectedValue();

     // hide dropdown when input field empty
	 if(query == "") dropdown.hide();

     if(query != "" && (query.toLowerCase() != 
			 			   last_query.toLowerCase() || any_change)) {
	     last_query = query;
	     any_change = false;
       
		 var nums = smsPlugin.abSearch(query);
		
		 window.resizeTo(270, 219); // allow extra space for dropdown to the right.
		 dropdown.populate(nums);
     }
   }

   var search_timer = null;
   function delayedSearch() {
	 if(!dropdown) return;					   

     var q = dropdown.unselectedValue();
     if(q != "" && q.toLowerCase() != last_query.toLowerCase()) {
	   last_query = q;
	   any_change = true;
     }

     if(search_timer != null) clearTimeout(search_timer);
     search_timer = setTimeout(search, search_delay_msecs);
   }

function resetInfoText() {
  document.getElementById("backmsg").innerHTML = 
   "<br />Visit <a style=\"color: red; font-weight: bold\" href=\"javascript:widget.openURL('" + baseURL + "');\">algoritmer.dk</a> for help on using widget.";
}

function setInfoText(msg) {
  if(msg.length == 0) resetInfoText();
  else document.getElementById("backmsg").innerText = msg;
}

function setInfoHTML(msg) {
  if(msg.length == 0) resetInfoText();
  else document.getElementById("backmsg").innerHTML = msg;
}

function loadCheckbox(name) {
   var value = getConfig(name);
   if(value == undefined) value = false;
   document.getElementById(name + "Setting").checked = value;
}

function saveCheckbox(name) {
    var value = document.getElementById(name + "Setting").checked;
    setConfig(name, value);
}

function load()
{
  setupParts();
  activateHiding('erasePhone', 'phonenum');
  activateHiding('eraseMessage', 'msg-content');
 
  var input = document.getElementById("phonenum");
  dropdown = mkDropDown(input, 'dropdown');
  tooltip = document.getElementById("tooltip");
    
  fixTooltips();
  resetInfoText();

  loadCheckbox("search");
  loadCheckbox("concat");
  loadCheckbox("log");
  loadCheckbox("receipt");
  
  value = widget.preferenceForKey(widget.identifier + "-phonenum");
  if(value != undefined) {
	var e = document.getElementById("phonenum");
    e.value = value;
  }
  phoneChanged();
     
  value = widget.preferenceForKey(widget.identifier + "-content");
  if(value != undefined) {
    var e = document.getElementById("msg-content");
	e.value = value;
  }
  contentChanged();
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
	// widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

var tooltip_timer = null;
function hideTooltip() {
	tooltip.style.display = "none";
	tooltip.my_parent = null;
	
	if(tooltip_timer != null) {
		clearTimeout(tooltip_timer);
		tooltip_timer = null;
	}
}

function fadeTooltip(opacity) {
	if(opacity == 0.0) tooltip.style.display = 'block';
	opacity += 0.2;
    tooltip.style.opacity = opacity;
	
	if(tooltip.style.opacity <= 1.0) {
		setTimeout("fadeTooltip(" + opacity + ")", tooltip_fade_msecs);
	}
}

var last_mouse_y, last_mouse_x;
function showTooltip(id) {
	var parent = document.getElementById(id);
	if(!parent) return;
	
	hideTooltip();
	if(!parent.my_tooltip || parent.my_tooltip == "") return;

	tooltip.innerText = parent.my_tooltip;
	var bottom = parent.parentElement.clientHeight;
    var x = last_mouse_x  - 13;//parent.offsetTop;
    var y = last_mouse_y + 15;//parent.offsetTop;

	tooltip.style.left = x + "px";
	tooltip.style.top = y + "px";
	tooltip.style.opacity = 0.0;
	tooltip.my_parent = parent;
	
	// increase widget working area to make room for tooltips at borders.
	window.resizeTo(260, 270);

	// display tooltip after timeout period
	if(tooltip_timer != null) clearTimeout(tooltip_timer);
	tooltip_timer = setTimeout("fadeTooltip(0.0)", tooltip_delay_msecs);
}

var title_ids = new Array("button", "msg", "bt", "searchCB", "concatCB", "logCB", "receiptCB",
                          "updateButton", "clear");
var title_vals = new Array("Use ^S to invoke with keyboard.", 
 						   "", "", 
						   "Lookup phone numbers in computers Address Book.",
                           "Allow messages longer than 160 characters. Not  all phones support this through bluetooth connection.",
                           'Write copy of all messages to "' + log_dir + '" in user directory.',
                           "Request receipt of delivery. Receipt only shows up on phone, and is not currently readable by widget.",
                           "Open web page with list of improvements and download link.",
                           "Clear both phone number and message text.");
function fixTooltips() {
	for(var i = 0; i < title_ids.length; ++i) {
		var e = document.getElementById(title_ids[i]);
		if(e) {
			e.my_tooltip = title_vals[i];
			eval("var fun = function() { last_mouse_y = event.y; last_mouse_x = event.x; showTooltip('" + e.id + "'); };");
			e.addEventListener('mousemove', fun, false);
			e.addEventListener('mouseout', hideTooltip, false);
		} 
	}
	tooltip.addEventListener('mousemove', hideTooltip, false);
	document.getElementById("body").addEventListener('keydown', hideTooltip, true);
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
  checkUpdates();

  // if backside was allready shown we update list of devices.
  if(document.getElementById("back").style.display != "none") {
	populateDevices();
  }
}

function showBack(event)
{
     window.resizeTo(206, 219); // remove extra space for dropdown to the right,
                                // it makes flip look really funky.
	populateDevices();

	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
  // store checkbox settings
  saveCheckbox("search");
  saveCheckbox("concat");
  saveCheckbox("log");
  saveCheckbox("receipt");
  if(document.getElementById("logSetting").checked) {
	// make sure log directory exists
	widget.system('mkdir -p "' + log_path + '"', null);
  }

	// your widget needs to show the front
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget) widget.prepareForTransition("ToFront");
	front.style.display="block";
	back.style.display="none";
	if(window.widget) setTimeout('widget.performTransition();', 0);
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}

function set_enabled(enabled) {
  document.getElementById("msg-content").disabled = !enabled;
  document.getElementById("phonenum").disabled = !enabled;

  document.getElementById("button").src = enabled ? "Images/send.png" : "Images/send-inactive.png";
  document.getElementById("clear").src = enabled ? "Images/clear.png" : "Images/clear-inactive.png";
}

function countOccurrence(haystack, needle) {
  var num = 0, pos = -1;
  for(;;) {
    pos = haystack.indexOf(needle, 1 + pos);
    if(pos < 0) return num;
    num += 1;    
  }
}

var last_phone = "";
var sms_cmd = null;
function setStatus(msg) {
  var problem = msg.length > 0;       
  if(!problem) msg = "Message to " + last_phone + " sent successfully.";
  else msg = "Unable to send message:\n" + msg;

  var bt = document.getElementById("bt");
  bt.my_tooltip = msg;
  bt.src = "Images/" + (problem ? "red" : "green") + ".png";
  set_enabled(true);
}
function resetStatus() {
  var bt = document.getElementById("bt");
  bt.my_tooltip = "";
  bt.src = "Images/black.png";
}

// remove name information and fix characters.
function filterPhone(phone) {
  // remove name info
  var pos = phone.indexOf("\xa0(");
  if(pos >= 0) phone = phone.substring(0, pos);

  // remove spaces, dots, dashes and remaining parenthesis
  phone = phone.replace(/[ ()\-\.\\\/]/g, "");
  
  return phone;
}

function getSMSC() {
	var smsc = getConfig(tty + "-smsc");
	if(smsc == undefined) smsc = "";
	return smsc;
}

function handleSendError(errmsg) {
	if(errmsg.toLowerCase().indexOf("+cms error: 330") >= 0) {
		var smsc = getSMSC();
		document.getElementById("smsc").value = smsc;
		document.getElementById("smscDialog").style.display = "block";
	}
}

function clearSMSC() {
	setConfig(tty + "-smsc", "");	
}

function storeSMSC() {
	var smsc = filterPhone(document.getElementById("smsc").value);
	setConfig(tty + "-smsc", smsc);
	document.getElementById("smscDialog").style.display = "none";	
}

function sendSMS(evt) 
{
  var phone = document.getElementById("phonenum");
  var content = document.getElementById("msg-content").value;

  // ignore sends when phone or content is empty.
  if(phone.value == "" || content.value == "") return;

  var phonenum = phone.value;
  debug("phonenum = " + phonenum);
  phone.value = phonenum; // unselect text
  phonenum = last_phone = filterPhone(phonenum);

  // turn off content-change action, when not needed
  if(content_timer != null) clearTimeout(content_timer);
	
  if(!tty) {
    setInfoText("Choose serial port before sending message.");
    showBack(evt);
    document.getElementById("terminal").focus();
    return;
  }
  
  set_enabled(false);
  var bt = document.getElementById("bt");
  bt.src = "Images/blue.png";
  bt.my_tooltip = "";

  dropdown.populate(new Array());

  var receipt = document.getElementById("receiptSetting").checked;
  smsPlugin.send(decorateDev(tty), getSMSC(), phonenum, content, receipt);
  setTimeout(checkSendDone, done_poll_msecs);  
}

function sendDone(errmsg) {
	// write to log if requested
	var msg = errmsg.substr(1);
	if(document.getElementById("logSetting").checked) {
		var phonenum = filterPhone(document.getElementById("phonenum").value);
		var content = document.getElementById("msg-content").value;
		
		var logfile = (errmsg == "+") ? '/Sent.txt' : '/Error.txt';

		var ephone = document.getElementById("phonenum").value.replace('"', '\\"');
		ephone = ephone.replace("\xa0", " ");
		var econtent = "\n" + content.replace('"', '\\"') + "\n";
		var header = "----------------------------------------\n";
		header += "Date: " + (new Date()).toString() + "\n";
		header += "To: " + ephone + "\n";
		if(msg != "") header += "Error: " + msg.replace('"', '\\"') + "\n";
		var logcmd = "(echo \"" + header + "\"; echo \"" +
		econtent + "\") >> \"" + log_path + logfile + '"';
		widget.system(logcmd, null);
	}

	//handleSendError(msg);
	setStatus(msg);

	document.getElementById("msg").innerText = "";
}

function checkSendDone() {
	document.getElementById("bt").src = "Images/blue.png";

	var msg = smsPlugin.getStatus();
	if(msg.indexOf("?") != 0) sendDone(msg);
	else {
		msg = msg.substr(1);
		document.getElementById("msg").innerText = msg + "...";
		setTimeout(checkSendDone, done_poll_msecs);  
	}
}

function keyPress(evt) {
  if(evt.ctrlKey && evt.charCode == 19) {
    sendSMS(evt);
    return false;
  } 
  return true;
}

function eraseContent() {
	document.getElementById("msg-content").value = "";
	contentChanged();
	document.getElementById("msg-content").value = "";
}

function ClearAll(evt) {
	document.getElementById("phonenum").value = "";
	document.getElementById("msg-content").value = "";
	phoneChanged();
	contentChanged();
	document.getElementById("phonenum").value = "";
	document.getElementById("msg-content").value = "";	
}

function delayedContentChanged() {
  var value = document.getElementById("msg-content").value;
  var chars = value.length;
  var num = smsPlugin.smsCount(value);

  var msg = chars + "/" + num;
  var e = document.getElementById("msg");
  if(chars > 0) {
  	e.innerText = msg;
    var characters = " character" + (chars == 1 ? "" : "s");
    var messages = " message" + (num == 1 ? "" : "s");
  	e.my_tooltip = "" + chars + characters + " in " + num + messages + ".";
  } else {
	e.innerText = e.my_tooltip = "";
  }

  widget.setPreferenceForKey(value, widget.identifier + "-content");
	
}

function contentChanged(evt) 
{
  resetStatus();
  somethingChanged();	
	
  var value = document.getElementById("msg-content").value;
  var concat = document.getElementById("concatSetting").checked;
  if(value.length >= sms_limit && !concat) {
    value = value.substring(0, sms_limit);
    document.getElementById("msg-content").value = value;
  }
  
  document.getElementById("msg").innerText = "";
  if(content_timer != null) clearTimeout(content_timer);
  content_timer = setTimeout(delayedContentChanged, content_delay_msecs);

  return true;
}

// return array of words, where str is delimited by space and
// regular punctuation.
function getWords(str) {
  var tokens = str.split(/[ \t\n\r,.;:"'"]/);
  var words = new Array();
  for(var i = 0; i < tokens.length; ++i) {
    if(tokens[i].length > 0) {
      words[words.length] = tokens[i];
    }
  }
  return words;
}

function buildPhoneInfo(str) {
  // extract manufacturer and model lines
  var lines = str.split("\n");
  var manufacturer = "", model = "", unknown = "";
  for(var i = 0; i < lines.length; ++i) {
    var l = lines[i];
    if(l.indexOf("i: ") == 0) manufacturer += l.substring(3) + " ";
    else if(l.indexOf("m: ") == 0) model += l.substring(3) + " ";
    else unknown += l + " ";
  }
  
  debug("manufacturer = '" + manufacturer + "'");
  debug("model = '" + model + "'");
  debug("unknown = '" + unknown + "'");
  
  // if manufacturer is more than one word, the first is taken
  manufacturer = getWords(manufacturer)[0];
  
  // if model string contains "model=" this is where data is
  var idx = model.toLowerCase().indexOf("model=");
  if(idx >= 0) {
    model = model.substring(idx + 6);
  }
  
  // if model contains manufacturer name, manufacturer is ignored
  idx = model.toLowerCase().indexOf(manufacturer.toLowerCase());
  if(idx >= 0) {
    model = model.substring(idx + manufacturer.length);
  }
  
  // take first number from model
  model = getWords(model)[0];

  return manufacturer + " " + model;
}

function testSerialPort(dev) {
  smsPlugin.test(decorateDev(dev));
  setTimeout(checkTestDone, done_poll_msecs);
}

function checkTestDone() {
	var msg = smsPlugin.getStatus();
	if(msg.indexOf("?") != 0) testDone(msg);
	else {
		msg = msg.substr(1);
		var dev = document.getElementById("terminal").value;
		setInfoText(msg + " " + dev + "...");
		setTimeout(checkTestDone, done_poll_msecs);
	}
}

function testDone(msg) {
  var e = document.getElementById("backmsg");
  var status = msg.substring(0, 1);
  msg = msg.substring(1);

  if(status == "+") {
    var dev = document.getElementById("terminal").value;
    var phoneID = buildPhoneInfo(msg);
    setInfoText(dev + " indentified as " + phoneID + ".");
    
    tty = dev;
	clearSMSC();
    setConfig("tty", tty);
  } else {
    setInfoText("Serial port did not respond properly:\n" + msg);
    document.getElementById("terminal").focus();
  }
  backEnabled(true);
}

function backEnabled(enabled) {
  document.getElementById("done").object.setEnabled(enabled);
  document.getElementById("updateButton").object.setEnabled(enabled);
  document.getElementById("terminal").disabled = !enabled;	
  document.getElementById("logSetting").disabled = !enabled;	
  document.getElementById("searchSetting").disabled = !enabled;	
  document.getElementById("concatSetting").disabled = !enabled;	
  document.getElementById("receiptSetting").disabled = !enabled;	
}

function terminalChanged(event) 
{
  var dev = document.getElementById("terminal").value;
  if(dev.length > 0) {
    setInfoText("Testing " + dev + "...");
    backEnabled(false);
    testSerialPort(dev);
  }
  return true;
}

function storePhone(evt) {
   var p = document.getElementById("phonenum");
   widget.setPreferenceForKey(p.value, widget.identifier + "-phonenum");
   return false;	
}

function somethingChanged() {
  var p = document.getElementById("phonenum");
  var c = document.getElementById("msg-content");
  var enabled = p.value.length > 0 && c.value.length > 0;
  document.getElementById("button").src = enabled ? "Images/send.png" : "Images/send-inactive.png";	

  var enabled = p.value.length > 0 || c.value.length > 0;
  document.getElementById("clear").src = enabled ? "Images/clear.png" : "Images/clear-inactive.png";
}

function phoneChanged(evt) 
{
  resetStatus();  
  somethingChanged();

  if(document.getElementById("searchSetting").checked) delayedSearch();

  return storePhone(evt);
}

function doUpdate(event) 
{
  if(updateURL != "") {
    document.getElementById("updateButton").style.display = "none";
    resetInfoText();
    widget.openURL(updateURL);
  }
}


function TestAll(event) 
{
	// Insert Code Here
}
